1、创建配置文件

- application.yml
- application-dev.yml
- application-prod.yml

```yaml
spring:
  profiles:
    active: @profileActive@
```

2、配置

pom.xml

```xml
<build>
    <resources>
             <resource>
                <directory>src/main/resources</directory>
                <filtering>true</filtering>
                <excludes>
                    <exclude>application*.yml</exclude>
                </excludes>
            </resource>
            <resource>
                <directory>src/main/resources</directory>
                <!-- 是否替换@xx@表示的maven properties属性值 -->
                <filtering>true</filtering>
                <includes>
                    <include>application.yml</include>
                    <include>application-${profileActive}.yml</include>
                </includes>
            </resource>
    </resources>
</build>


<profiles>
    <profile>
        <id>dev</id>
        <activation>
            <activeByDefault>true</activeByDefault>
        </activation>
        <properties>
            <profileActive>dev</profileActive>
            <java_opts>-server -Xms256m -Xmx256m -XX:NewSize=128m -XX:MaxNewSize=128m -Xss256k</java_opts>
        </properties>
    </profile>
    <!--生产环境-->
    <profile>
        <id>prod</id>
        <properties>
            <profileActive>prod</profileActive>
            <java_opts>
                <!--                    -server -server -Xmx12g -Xms12g -Xss1m -XX:MetaspaceSize=512m -XX:MaxMetaspaceSize=512m-->
                <!--                    -XX:SurvivorRatio=8 -XX:+UseG1GC -XX:+AlwaysPreTouch -XX:-ResizePLAB -XX:MaxGCPauseMillis=300-->
                <!--                    -XX:+UnlockExperimentalVMOptions -XX:G1NewSizePercent=20 -XX:G1MaxNewSizePercent=60-->
                <!--                    -XX:+ParallelRefProcEnabled -Xloggc:/home/work/ai-algo-aat/logs/start_gc_%p.log -XX:+PrintGCDetails-->
                <!--                    -XX:+PrintGCTimeStamps -XX:NumberOfGCLogFiles=5 -XX:GCLogFileSize=30M-->
                <!--                    -XX:ParallelGCThreads=4 -XX:ConcGCThreads=4-->
            </java_opts>
        </properties>
    </profile>
</profiles>

```

