> **综合安防平台数据接入平台功能**
>
> - 添加`综合安防平台对接表`表
>
> - 添加`综合安防平台设备表`表
>
> - 添加菜单
>
> - 修改`pc_monitoring_device`表 `imei` 字段长度，添加`security_id`关联字段
>
> **添加参数配置**
>
> - 添加`data_report_state`参数: `true`：数据上报， `false`：数据不上报
>
> - 添加 `data_report_to_intranet_url`：上报地址（内网）
> - 添加 `data_report_to_extranet_url`：上报地址（外网）
> - 添加`data_report_type`：`intranet`：推送内网，`extranet`：推送外网
> - 添加外网推送方式的用户名密码：`data_report_for_username`：用户名，`data_report_for_password`：密码
> - 添加`data_report_for_auth_url`获取token的地址

```sql
CREATE TABLE `pc_monitoring_device_security` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ip` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'IP',
  `port` varchar(8) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '端口号',
  `app_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'appKey',
  `app_secret` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'appSecret',
  `descript` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '描述',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `dept_id` int DEFAULT NULL COMMENT '部门ID',
  `job_id` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '定时任务ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='综合安防平台对接表';

CREATE TABLE `pc_monitoring_security_info` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ip` varchar(20) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '设备IP',
  `port` varchar(5) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '端口号',
  `device_type` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '设备系列',
  `dev_serial_num` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '设备序列号',
  `manufacturer` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '厂商',
  `camera_index_code` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '监控点唯一标识',
  `camera_name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '监控点名称',
  `camera_type_name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '监控点类型',
  `channel_no` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '通道编号',
  `channel_type_name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '通道类型',
  `encode_dev_index_code` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '所属编码设备唯一标识',
  `encode_dev_resource_type_name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '所属设备类型',
  `region_index_code` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '所属区域唯一标识',
  `security_id` int NOT NULL COMMENT '综合安防对接ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='综合安防平台设备信息';

##菜单

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接', '3000', '1', '/pc/monitoring_device_security', 'C', '0', 'pc:monitoring_device_security:view', '#', 'admin', sysdate(), '', null, '综合安防平台对接菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接查询', @parentId, '1',  '#',  'F', '0', 'pc:monitoring_device_security:list','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接新增', @parentId, '2',  '#',  'F', '0', 'pc:monitoring_device_security:add','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接修改', @parentId, '3',  '#',  'F', '0', 'pc:monitoring_device_security:edit','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接删除', @parentId, '4',  '#',  'F', '0', 'pc:monitoring_device_security:remove','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('综合安防平台对接导出', @parentId, '5',  '#',  'F', '0', 'pc:monitoring_device_security:export','#', 'admin', sysdate(), '', null, '');

#修改通道号长度
ALTER TABLE `pc_monitoring_device` 
MODIFY COLUMN `imei` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NULL DEFAULT NULL COMMENT '通道号' AFTER `unique_code`;

#添加security_id
ALTER TABLE `pc_monitoring_device` 
ADD COLUMN `security_id` int DEFAULT '0' COMMENT 'securityId'  AFTER `address`;

#添加参数
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报开关', 'data_report_state', 'true', 'Y', 'admin', '2022-12-02 16:59:46', '', NULL, 'true`：数据上报， false：数据不上报');
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报接口地址（内网）', 'data_report_to_intranet_url', 'http://116.62.46.126:32081/data-service/video/alarm', 'Y', 'admin', '2022-12-02 17:01:15', '', NULL, NULL);
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报接口地址（外网）', 'data_report_to_extranet_url', 'http://192.168.2.65:32081/data-service/video/alarm', 'Y', 'admin', '2022-12-02 17:01:46', '', NULL, NULL);
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报方式', 'data_report_type', 'intranet', 'Y', 'admin', '2022-12-02 17:02:32', '', NULL, 'intranet：推送内网，extranet：推送外网');
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报用户名', 'data_report_for_username', 'hjkj', 'Y', 'admin', '2022-12-02 17:03:13', '', NULL, NULL);
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报密码', 'data_report_for_password', 'zjgbsq@hj', 'Y', 'admin', '2022-12-02 17:03:37', '', NULL, NULL);
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('第三方数据上报获取authToken', 'data_report_for_auth_url', 'https://116.62.46.126:32089/oauth/token?grant_type=client_credentials', 'Y', 'admin', '2022-12-05 10:18:34', '', NULL, '第三方数据上报获取authToken');
```



# 项目更新

> 基于`V2.0.3.1`更新

```
docker pull registry.cn-hangzhou.aliyuncs.com/jeffrey_ai/aibox:v2.1.0.1

```















































