```sql
-- 车牌白名单
CREATE TABLE `pc_ocr_whitelist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `number_plate` varchar(10) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '车牌号',
  `dept_name` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '部门',
  `contact_person` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '联系人',
  `contact_phone_num` varchar(11) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '联系电话',
  `del_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 未删除  1 删除',
  `create_id` int(11) DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8 DEFAULT NULL COMMENT '创建时间',
  `update_id` int(11) DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8 DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Ocr车牌识别白名单';


-- 修改ocr结果信息表
ALTER TABLE `pc_ocr_lpr_result` 
ADD COLUMN `type` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1 非白名单  2：白名单' AFTER `result_date`,
ADD COLUMN `belong_dept_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NULL DEFAULT NULL COMMENT '部门' AFTER `type`,
ADD COLUMN `contact_person` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NULL DEFAULT NULL COMMENT '联系人' AFTER `dept_name`,
ADD COLUMN `contact_phone_num` varchar(11) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NULL DEFAULT NULL COMMENT '联系电话' AFTER `contact_person`,
DROP PRIMARY KEY,
ADD PRIMARY KEY (`id`) USING BTREE;

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单', '3200', '1', '/pc/pc_ocr_whitelist', 'C', '0', 'pc:pc_ocr_whitelist:view', '#', 'admin', sysdate(), '', null, 'Ocr车牌识别白名单菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单查询', @parentId, '1',  '#',  'F', '0', 'pc:pc_ocr_whitelist:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单新增', @parentId, '2',  '#',  'F', '0', 'pc:pc_ocr_whitelist:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单修改', @parentId, '3',  '#',  'F', '0', 'pc:pc_ocr_whitelist:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单删除', @parentId, '4',  '#',  'F', '0', 'pc:pc_ocr_whitelist:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('Ocr车牌识别白名单导出', @parentId, '5',  '#',  'F', '0', 'pc:pc_ocr_whitelist:export',       '#', 'admin', sysdate(), '', null, '');

```







```apache
docker run  --env WVP_IP="192.168.1.14" -it -p 18080:18080 -p 30000-30500:30000-30500/udp -p 30000-30500:30000-30500/tcp -p 8008:80 -p 5060:5060 -p 5060:5060/udp 648540858/wvp_pro
```
