> 数据库变更
> `pc_monitoring_device_model`表添加字字段
>
> - `save_video_detail`是否保留前后视频详情
> - `save_video_time`保留前后视频时间

```
change_video_base
```

```sql
ALTER TABLE `pc_monitoring_device_model` 
ADD COLUMN `save_video_detail` tinyint NULL DEFAULT 0 COMMENT '是否保存前后视频详情 1 保存  0 不保存' AFTER `is_save`,
ADD COLUMN `save_video_time` int NULL COMMENT '保留前后视频时间 单位秒' AFTER `save_video_detail`;


UPDATE `pc_monitoring_device_model` SET `save_video_detail` = 0 WHERE save_video_detail IS NULL


-- ALTER TABLE `aicsp`.`pc_monitoring_device_model` 
-- MODIFY COLUMN `save_video_detail` tinyint NULL DEFAULT 0 COMMENT '是否保存前后视频详情 1 保存  0 不保存' AFTER `is_save`

ALTER TABLE `pc_monitoring_device_result` 
ADD COLUMN `video_status` tinyint NULL DEFAULT 0 COMMENT '保存视频状态 0:没有操作  1：正在生成视频 2：生成视频成功 3：生成视频失败' AFTER `result`

ALTER TABLE `pc_monitoring_device_result` 
ADD COLUMN `video_path` varchar(255) NULL COMMENT '视频地址' AFTER `video_status`

INSERT INTO `sys_config` (`config_id`, `config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('保存视频结果前后视频接口', 'save_video_result_api', 'http://127.0.0.1:10007/get_short_video', 'Y', 'admin', '2023-03-14 14:57:16', '', NULL, NULL);

```



# 使用坐标点进行对比检测

```sql
INSERT INTO `sys_config` (`config_name`, `config_key`, `config_value`, `config_type`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('需要进行坐标点检测的模型', 'coordinate_point_comparison_model_setting', '模型ID,多个使用，号隔开', 'Y', 'admin', '2023-06-30 07:15:22', '', NULL, NULL);

```





```
// 6,345,309,574
//[
// [6,345] 左下
// [309,345]  右下
// [309,574] 右上
// [6,574] 左上
// ]
// 118,278,354,507
//[
// [118,278]  左上
// [354,278] 右上
// [354,507] 右下
// [118,507] 左下
// ]


[[{"oX":729,"oY":150},{"oX":30,"oY":741},{"oX":252,"oY":1065},{"oX":525,"oY":1059},{"oX":921,"oY":354}],[{"oX":1410,"oY":210},{"oX":1218,"oY":360},{"oX":1509,"oY":1050},{"oX":1830,"oY":1047},{"oX":1857,"oY":687}],
[{"oX":600,"oY":567},{"oX":1092,"oY":630}]]



[[{"oX":729,"oY":150},{"oX":30,"oY":741},{"oX":252,"oY":1065},{"oX":525,"oY":1059},{"oX":921,"oY":354}],[{"oX":1410,"oY":210},{"oX":1218,"oY":360},{"oX":1509,"oY":1050},{"oX":1830,"oY":1047},{"oX":1857,"oY":687}],
[{"oX":600,"oY":567},{"oX":1092,"oY":630}],
[{"oX":714,"oY":741}],
[{"oX":675,"oY":825},{"oX":876,"oY":639}]]


[[{"oX":729,"oY":150},{"oX":30,"oY":741},{"oX":252,"oY":1065},{"oX":525,"oY":1059},{"oX":921,"oY":354}],[{"oX":1410,"oY":210},{"oX":1218,"oY":360},{"oX":1509,"oY":1050},{"oX":1830,"oY":1047},{"oX":1857,"oY":687}]
,[{"oX":12,"oY":1047}]]


675,825
876,


1000,567,1202,766
[
[1000,567],
[1002,567],
[1002,766],
[800,766]
]
```

ALTER TABLE `pc_ai_model` 
ADD COLUMN   `syn_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '同步时间';
