# 宿迁高铁站



 > 
 >
 > ### OcrSql
 >
 >  

```sql
-- led设备管理
CREATE TABLE `pc_led_system` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'id',
  `dept_id` int NOT NULL COMMENT '部门ID',
  `ip` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Ip',
  `port` varchar(5) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '端口号',
  `model` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '型号',
  `name` varchar(30) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '设备名称',
  `status` int DEFAULT '0' COMMENT '设备应用状态 0 激活 1 禁用',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `content` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'LED控制器需要显示的内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='led设备管理';

-- 通道关联led设备
CREATE TABLE `pc_led_system_device` (
  `id` int NOT NULL AUTO_INCREMENT,
  `monitoring_device_id` int DEFAULT NULL COMMENT '监控通道Id',
  `led_system_id` int DEFAULT NULL COMMENT 'led设备Id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='通道关联led设备';

-- LED设备管理播控记录表 sql
CREATE TABLE `pc_led_play_record` (
  `id` int NOT NULL AUTO_INCREMENT,
  `create_date` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `del_flag` int DEFAULT NULL COMMENT '删除标记',
  `dept_id` bigint DEFAULT NULL COMMENT '部门Id',
  `monitoring_device_id` int NOT NULL COMMENT '通道ID',
  `led_system_id` int NOT NULL COMMENT 'led设备ID',
  `content` text CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci COMMENT '操作内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='LED设备管理播控记录';

-- ocr通道和音柱设备关联表
CREATE TABLE `pc_ocr_device_volume` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ocr_device_id` int DEFAULT NULL COMMENT '监控通道Id',
  `device_id` int DEFAULT NULL COMMENT '音柱设备Id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COMMENT='ocr通道和音柱设备关联表';

-- ocr监控通道表
CREATE TABLE `pc_ocr_device` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `dept_id` int DEFAULT NULL COMMENT '部门ID',
  `name` varchar(30) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '通道名称',
  `imei` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '通道号',
  `app_status` int DEFAULT '0' COMMENT '通道应用状态 1 激活 0 禁用',
  `online_status` int DEFAULT '1' COMMENT '通道在线状态 0 在线 1 离线',
  `streaming_address` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '通道推流地址',
  `address` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '通道详细地址',
  `background` varchar(255) DEFAULT NULL COMMENT '背景图',
  `coordinate` varchar(255) DEFAULT NULL COMMENT 'ROI坐标',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COMMENT='ocr监控通道表';

-- OCR监控任务
CREATE TABLE `pc_ocr_lpr_task` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '播控任务ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `user_id` bigint DEFAULT NULL COMMENT '创建人ID',
  `dept_id` bigint DEFAULT NULL COMMENT '部门ID',
  `name` varchar(200) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '监控任务名称',
  `audio_type` tinyint(1) DEFAULT '1' COMMENT '音频方式  1：文字转语音 2：音频文件上传',
  `audio_url` varchar(200) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '音频资源',
  `audio_text` varchar(50) DEFAULT NULL COMMENT '文字转语音的文字',
  `status` int DEFAULT NULL COMMENT '监控任务状态: 0禁用，1启用',
  `recognition_mode` int DEFAULT NULL COMMENT '识别模式：0：抽帧识别，1：视频分析（推流），2：视频分析（不推流）',
  `date_type` int DEFAULT NULL COMMENT '播放日期类型: 0指定周期，1指定日期',
  `date_week` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '播放指定周期：2,3,4,5,6,7,1 表示周一到周日 ',
  `date_content` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '播放指定日期：2020-08-20',
  `play_form` int DEFAULT NULL COMMENT '播放形式：0 一次播放 ，1 循环播放',
  `start_time` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '一次播放开始时间 / 循环播放开始时间',
  `end_time` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '循环播放结束时间',
  `time_interval` int DEFAULT NULL COMMENT '循环播放时间间隔',
  `job_id` varchar(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '定时任务ID',
  `time_threshold` int DEFAULT NULL COMMENT '周期',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='监控任务表';

-- ocr监控任务和监控通道关联表
CREATE TABLE `pc_ocr_lpr_task_device` (
  `id` int NOT NULL AUTO_INCREMENT,
  `task_id` int DEFAULT NULL COMMENT '监控任务Id',
  `ocr_device_id` int DEFAULT NULL COMMENT 'ocr通道Id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb3 COMMENT='ocr监控任务和监控通道关联表';

-- 监控设备监测结果表
CREATE TABLE `pc_ocr_lpr_result` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `dept_id` int DEFAULT NULL COMMENT '部门ID',
  `ocr_device_id` int DEFAULT NULL COMMENT '监控设备ID',
  `score` double DEFAULT NULL COMMENT '相似度',
  `content` varchar(255) DEFAULT NULL COMMENT '车牌检测',
  `img_url` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '图片地址',
  `result` text CHARACTER SET utf32 COLLATE utf32_general_ci COMMENT '测算结果',
  `result_date` varchar(20) DEFAULT NULL COMMENT '结果时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8mb3 COMMENT='监控设备监测结果表';

-- --------------------------------------------------------------------------------------------------------------------------------
-- open_or_close_statue 字典
INSERT INTO `sys_dict_type` (`dict_name`, `dict_type`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('启用禁用状态', 'open_or_close_statue', '0', 'admin', '2023-02-22 11:52:03', '', NULL, NULL);

INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (1, '启用', '1', 'open_or_close_statue', '', 'primary', 'Y', '0', 'admin', '2023-02-22 11:52:32', 'admin', '2023-02-22 11:53:00', '启用状态');
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (2, '禁用', '0', 'open_or_close_statue', '', 'danger', 'N', '0', 'admin', '2023-02-22 11:52:48', 'admin', '2023-02-22 11:53:06', '禁用状态');


-- 添加 LED设备控制管理 菜单

INSERT INTO `sys_menu` (`menu_name`, `parent_id`, `order_num`, `url`, `target`, `menu_type`, `visible`, `is_refresh`, `perms`, `icon`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('LED设备控制管理', 0, 12, '#', 'menuItem', 'M', '0', '1', '', 'fa fa-microchip', 'admin', '2023-02-22 11:07:10', 'admin', '2023-02-24 10:44:43', '');
-- 按钮父菜单ID
SELECT @topParentId := LAST_INSERT_ID();

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理',  @topParentId, '1', '/pc/led_system', 'C', '0', 'pc:led_system:view', '#', 'admin', sysdate(), '', null, 'led设备管理菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理查询', @parentId, '1',  '#',  'F', '0', 'pc:led_system:list','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理新增', @parentId, '2',  '#',  'F', '0', 'pc:led_system:add', '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理修改', @parentId, '3',  '#',  'F', '0', 'pc:led_system:edit','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理删除', @parentId, '4',  '#',  'F', '0', 'pc:led_system:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('led设备管理导出', @parentId, '5',  '#',  'F', '0', 'pc:led_system:export',       '#', 'admin', sysdate(), '', null, '');

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备', @topParentId, '1', '/pc/led_system_device', 'C', '0', 'pc:led_system_device:view', '#', 'admin', sysdate(), '', null, '通道关联led设备菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备查询', @parentId, '1',  '#',  'F', '0', 'pc:led_system_device:list','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备新增', @parentId, '2',  '#',  'F', '0', 'pc:led_system_device:add', '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备修改', @parentId, '3',  '#',  'F', '0', 'pc:led_system_device:edit','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备删除', @parentId, '4',  '#',  'F', '0', 'pc:led_system_device:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('通道关联led设备导出', @parentId, '5',  '#',  'F', '0', 'pc:led_system_device:export',       '#', 'admin', sysdate(), '', null, '');

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录', @topParentId, '1', '/pc/led_system_play_record', 'C', '0', 'pc:led_system_play_record:view', '#', 'admin', sysdate(), '', null, 'LED设备管理播控记录菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录查询', @parentId, '1',  '#',  'F', '0', 'pc:led_system_play_record:list','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录新增', @parentId, '2',  '#',  'F', '0', 'pc:led_system_play_record:add', '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录修改', @parentId, '3',  '#',  'F', '0', 'pc:led_system_play_record:edit','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录删除', @parentId, '4',  '#',  'F', '0', 'pc:led_system_play_record:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('LED设备管理播控记录导出', @parentId, '5',  '#',  'F', '0', 'pc:led_system_play_record:export',       '#', 'admin', sysdate(), '', null, '');

-- 车牌识别
INSERT INTO `sys_menu` (`menu_name`, `parent_id`, `order_num`, `url`, `target`, `menu_type`, `visible`, `is_refresh`, `perms`, `icon`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('车牌识别管理牌', 0, 13, '#', 'menuItem', 'M', '0', '1', NULL, 'fa fa-car', 'admin', '2023-02-24 11:46:48', '', NULL, '');

-- 按钮父菜单ID
SELECT @topParentIdForOcr := LAST_INSERT_ID();
-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道', @topParentIdForOcr, '1', '/pc/ocr_device', 'C', '0', 'pc:ocr_device:view', '#', 'admin', sysdate(), '', null, 'ocr监控通道菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道查询', @parentId, '1',  '#',  'F', '0', 'pc:ocr_device:list','#','admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道新增', @parentId, '2',  '#',  'F', '0', 'pc:ocr_device:add', '#','admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道修改', @parentId, '3',  '#',  'F', '0', 'pc:ocr_device:edit','#','admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道删除', @parentId, '4',  '#',  'F', '0', 'pc:ocr_device:remove','#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr监控通道导出', @parentId, '5',  '#',  'F', '0', 'pc:ocr_device:export','#', 'admin', sysdate(), '', null, '');


-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务', @topParentIdForOcr, '1', '/pc/ocr_lpr_task', 'C', '0', 'pc:ocr_lpr_task:view', '#', 'admin', sysdate(), '', null, 'ocr车牌监控任务菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务查询', @parentId, '1',  '#',  'F', '0', 'pc:ocr_lpr_task:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务新增', @parentId, '2',  '#',  'F', '0', 'pc:ocr_lpr_task:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务修改', @parentId, '3',  '#',  'F', '0', 'pc:ocr_lpr_task:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务删除', @parentId, '4',  '#',  'F', '0', 'pc:ocr_lpr_task:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控任务导出', @parentId, '5',  '#',  'F', '0', 'pc:ocr_lpr_task:export',       '#', 'admin', sysdate(), '', null, '');


-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果', @topParentIdForOcr, '1', '/pc/ocr_lpr_result', 'C', '0', 'pc:ocr_lpr_result:view', '#', 'admin', sysdate(), '', null, 'ocr车牌监控结果菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果查询', @parentId, '1',  '#',  'F', '0', 'pc:ocr_lpr_result:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果新增', @parentId, '2',  '#',  'F', '0', 'pc:ocr_lpr_result:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果修改', @parentId, '3',  '#',  'F', '0', 'pc:ocr_lpr_result:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果删除', @parentId, '4',  '#',  'F', '0', 'pc:ocr_lpr_result:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr车牌监控结果导出', @parentId, '5',  '#',  'F', '0', 'pc:ocr_lpr_result:export',       '#', 'admin', sysdate(), '', null, '');

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联', @topParentIdForOcr, '1', '/pc/ocr_device_volume', 'C', '0', 'pc:ocr_device_volume:view', '#', 'admin', sysdate(), '', null, 'ocr通道和音柱设备关联菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联查询', @parentId, '1',  '#',  'F', '0', 'pc:ocr_device_volume:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联新增', @parentId, '2',  '#',  'F', '0', 'pc:ocr_device_volume:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联修改', @parentId, '3',  '#',  'F', '0', 'pc:ocr_device_volume:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联删除', @parentId, '4',  '#',  'F', '0', 'pc:ocr_device_volume:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('ocr通道和音柱设备关联导出', @parentId, '5',  '#',  'F', '0', 'pc:ocr_device_volume:export',       '#', 'admin', sysdate(), '', null, '');

INSERT INTO `sys_dict_type` (`dict_name`, `dict_type`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('LED设备型号信息', 'led_system_model', '0', 'admin', '2023-02-22 11:29:18', '', NULL, 'LED设备型号信息');

INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (1, 'JT50', 'JT50', 'led_system_model', NULL, NULL, 'Y', '0', 'admin', '2023-02-22 11:32:32', '', NULL, NULL);
```

> 
>
> ### 添加摄像头类型
>
>  


```sql
ALTER TABLE `pc_monitoring_device` 
ADD COLUMN `device_type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT "online_video_address" COMMENT '流地址类型' AFTER `background_image`;

ALTER TABLE `pc_ocr_device` 
ADD COLUMN `device_type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT "online_video_address" COMMENT '流地址类型' AFTER `coordinate`;

INSERT INTO `sys_dict_type` (`dict_name`, `dict_type`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('视频通道设备类型', 'device_type', '0', 'admin', '2023-05-08 08:22:04', '', NULL, NULL);
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (1, '大华', 'camera_dahua_address', 'device_type', NULL, NULL, 'N', '0', 'admin', '2023-05-08 08:22:44', '', NULL, NULL);
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (2, '海康', 'camera_haikang_address', 'device_type', '', '', 'N', '0', 'admin', '2023-05-08 08:23:01', 'admin', '2023-05-08 08:23:12', '');
INSERT INTO `sys_dict_data` ( `dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (3, '本地资源', 'local_video_address', 'device_type', '', '', 'N', '0', 'admin', '2023-05-08 08:23:53', 'admin', '2023-05-08 08:24:51', '如本地mp4');
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (4, '线上资源', 'online_video_address', 'device_type', NULL, NULL, 'Y', '0', 'admin', '2023-05-08 08:24:39', '', NULL, '如rtsp，rtmp，flv等');
```
