```sql
CREATE TABLE `pc_law_enforcement_video` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `name` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '视频名称',
  `video_path` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '视频路径',
  `video_type` int DEFAULT NULL COMMENT '视频分类',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=60 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='执法视频管理';


CREATE TABLE `pc_law_enforcement_video_type` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `del_flag` int DEFAULT '0' COMMENT '删除标记',
  `create_id` int DEFAULT NULL COMMENT '创建人ID',
  `create_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '创建时间',
  `update_id` int DEFAULT NULL COMMENT '更新人ID',
  `update_date` varchar(20) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL COMMENT '更新时间',
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '视频名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='执法视频类别';

CREATE TABLE `pc_download_task` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `content` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '压缩包包含的视频数据',
  `status` tinyint(1) NOT NULL COMMENT '任务状态  0 ：失败  1：正在压缩 2：压缩成功 ',
  `path` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '压缩包路径',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;


INSERT INTO `aicsp`.`sys_menu` (`menu_name`, `parent_id`, `order_num`, `url`, `target`, `menu_type`, `visible`, `is_refresh`, `perms`, `icon`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('执法视频管理', 0, 11, '#', 'menuItem', 'M', '0', '1', NULL, 'fa fa-cloud-upload', 'admin', '2023-02-15 11:15:57', '', NULL, '');
-- 按钮父菜单ID
SELECT @topParentId := LAST_INSERT_ID();

-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理', @topParentId, '1', '/pc/law_enforcement_video', 'C', '0', 'pc:law_enforcement_video:view', '#', 'admin', sysdate(), '', null, '执法视频管理菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理查询', @parentId, '1',  '#',  'F', '0', 'pc:law_enforcement_video:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理新增', @parentId, '2',  '#',  'F', '0', 'pc:law_enforcement_video:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理修改', @parentId, '3',  '#',  'F', '0', 'pc:law_enforcement_video:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理删除', @parentId, '4',  '#',  'F', '0', 'pc:law_enforcement_video:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频管理导出', @parentId, '5',  '#',  'F', '0', 'pc:law_enforcement_video:export',       '#', 'admin', sysdate(), '', null, '');


-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别', @topParentId, '1', '/pc/law_enforcement_video_type', 'C', '0', 'pc:law_enforcement_video_type:view', '#', 'admin', sysdate(), '', null, '执法视频类别菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别查询', @parentId, '1',  '#',  'F', '0', 'pc:law_enforcement_video_type:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别新增', @parentId, '2',  '#',  'F', '0', 'pc:law_enforcement_video_type:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别修改', @parentId, '3',  '#',  'F', '0', 'pc:law_enforcement_video_type:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别删除', @parentId, '4',  '#',  'F', '0', 'pc:law_enforcement_video_type:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('执法视频类别导出', @parentId, '5',  '#',  'F', '0', 'pc:law_enforcement_video_type:export',       '#', 'admin', sysdate(), '', null, '');



-- 菜单 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务', @topParentId, '1', '/pc/download_task', 'C', '0', 'pc:download_task:view', '#', 'admin', sysdate(), '', null, '下载任务菜单');

-- 按钮父菜单ID
SELECT @parentId := LAST_INSERT_ID();

-- 按钮 SQL
insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务查询', @parentId, '1',  '#',  'F', '0', 'pc:download_task:list',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务新增', @parentId, '2',  '#',  'F', '0', 'pc:download_task:add',          '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务修改', @parentId, '3',  '#',  'F', '0', 'pc:download_task:edit',         '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务删除', @parentId, '4',  '#',  'F', '0', 'pc:download_task:remove',       '#', 'admin', sysdate(), '', null, '');

insert into sys_menu (menu_name, parent_id, order_num, url, menu_type, visible, perms, icon, create_by, create_time, update_by, update_time, remark)
values('下载任务导出', @parentId, '5',  '#',  'F', '0', 'pc:download_task:export',       '#', 'admin', sysdate(), '', null, '');


INSERT INTO `sys_dict_type` (`dict_name`, `dict_type`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES ('生成视频状态', 'download_task_status', '0', 'admin', '2023-02-17 16:43:57', '', NULL, NULL);

INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `updrtsp://admin:hjkj123qaz@192.168.1.15:554/h264/ch1/main/av_streamate_by`, `update_time`, `remark`) VALUES (1, '压缩失败', '0', 'download_task_status', '', 'danger', 'Y', '0', 'admin', '2023-02-17 16:44:37', 'admin', '2023-02-17 16:45:23', '');
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (2, '正在压缩', '1', 'download_task_status', '', 'info', 'Y', '0', 'admin', '2023-02-17 16:44:49', 'admin', '2023-02-17 16:45:19', '');
INSERT INTO `sys_dict_data` (`dict_sort`, `dict_label`, `dict_value`, `dict_type`, `css_class`, `list_class`, `is_default`, `status`, `create_by`, `create_time`, `update_by`, `update_time`, `remark`) VALUES (3, '压缩成功', '2', 'download_task_status', '', 'primary', 'Y', '0', 'admin', '2023-02-17 16:45:11', 'admin', '2023-02-17 16:51:11', '');



```



