#### 启动redis

```shell
service redis start/stop/restart
```

#### 启动mysql

```shell
service mysql start
```

#### 启动SRS

```shell
nohup /usr/local/server/srs/trunk/objs/srs -c /usr/local/server/srs/trunk/conf/srs.conf >/dev/null 2>&1 &
```

#### 启动Tomcat

```shell
/usr/local/server/apache-tomcat/bin/startup.sh
```

#### 启动saas平台

```shell
/usr/local/server/aicsp/ai-ipc.sh start
```















#### Redis 服务设置 service启动

```bash
#!/bin/sh
# description: Start and Stop redis,Redis is a persistent key-value database   
# chkconfig: 2345 90 10
# chkconfig: 2345 10 90
# description: Start and Stop redis
 
REDISPORT=6379 #实际环境而定
EXEC=/usr/local/bin/redis-server #实际环境而定
REDIS_CLI=/usr/local/bin/redis-cli #实际环境而定
 
PIDFILE=/var/run/redis_6379.pid
CONF="/usr/local/server/redis-7.0.3/redis.conf" #实际环境而定
 
case "$1" in
        start)
                if [ -f $PIDFILE ]
                then
                        echo "$PIDFILE exists, process is already running or crashed."
                else
                        echo "Starting Redis server..."
                        $EXEC $CONF
                fi
                if [ "$?"="0" ]
                then
                        echo "Redis is running..."
                fi
                ;;
        stop)
                if [ ! -f $PIDFILE ]
                then
                        echo "$PIDFILE exists, process is not running."
                else
                        PID=$(cat $PIDFILE)
                        echo "Stopping..."
                        $REDIS_CLI -p $REDISPORT SHUTDOWN
                        while [ -x $PIDFILE ]
                        do
                                echo "Waiting for Redis to shutdown..."
                                sleep 1
                        done
                        echo "Redis stopped"
                fi
                ;;
        restart|force-reload)
                ${0} stop
                ${0} start
                ;;
        *)
                echo "Usage: /etc/init.d/redis {start|stop|restart|force-reload}" >&2
                exit 1
esac

```



docker run \
-p 9002:80 \
--name nginx \
-v /home/nginx/conf/nginx.conf:/etc/nginx/nginx.conf \
-v /home/nginx/conf/conf.d:/etc/nginx/conf.d \
-v /home/nginx/log:/var/log/nginx \
-v /home/nginx/html:/usr/share/nginx/html \
-d nginx:latest
