### 盒子错误解决方案

> 访问、登录报`404`

**错误原因1：**可能由于机器重启，nginx服务还没有启动完成

**解决方案：**等待片刻再进行访问重试即可。

**错误原因2：**如果方案一还是不能进行访问，那就是有可能是服务启动过程中出现问题。

**解决方案：**`sudo docker ps `查看服务是否都已经启动，含

`mysql`、`nginx`、`redis`、`boliving`、`ai_platform_test`

如有未启动，可执行`sudo sh /home/nvidia/step.sh`进行重启



> 算法管理算法列表图片展示异常

<img src="/Users/Jeffrey/Library/Application Support/typora-user-images/image-20220412144022837.png" alt="image-20220412144022837"  />

**原因1：** 登录盒子数据库，查看`algo`找到对应的算法，查看`icon_url`，盒子数据为`http://116.198.37.170:80/upload/comm/1647496478066_Baidu_217__2022-03-04_0001.jpeg`格式访问不到图片的话，那么盒子无法进行连接外网，

**解决方案：** 删除`icon_url`中的前缀IP地址,修改为`/upload/comm/1647496478066_Baidu_217__2022-03-04_0001.jpeg`格式，并经`1647496478066_Baidu_217__2022-03-04_0001.jpeg`图片迁移到服务器`/data2/ai-algo-aat/upload/comm`目录下。



**原因2：**若当前`url_url`已经是不含IP的格式，只需检查服务器对应的目录下是否有该张图片资源。

**解决方案：**查看`/data2/ai-algo-aat/upload/comm`目录下是否有对应的图片资源，没有的话进行迁移即可。



> 报错：`"nested exception is org.apache.ibatis.builder.BuilderException: The expression 'ids' evaluated to a null value."`

![image-20220412145723466](http://doc.zhangfayuan.cn/tmp/d8c1772d2d23306ba85a525525e14df6/工作文档/Users/Jeffrey/Library/Application Support/typora-user-images/image-20220412145723466.png)

**原因：**由于系统长时间为进行页面操作导致平台`token`过期，使用该凭证进行接口请求的时候会报这个错误。

**解决方案：**重新刷新页面登录即可。（新版本中已经修复该报错）



> 报错：`"No such file or directory:'/data/cache/328/models/weights/best.pt'`

![image-20220412145644613](http://doc.zhangfayuan.cn/tmp/d8c1772d2d23306ba85a525525e14df6/工作文档/Users/Jeffrey/Library/Application Support/typora-user-images/image-20220412145644613.png)

**原因：**服务器中不含有模型文件或者是含有模型文件，路径地址与数据库中对应的地址不一致。

**解决方案：**查看对应的服务器目录下是否韩友谊对应的模型文件：`/data2/ai-algo-aat/cache/328/models/weights`目录下是否含有`best.pt`、`last.pt`文件,

如果没有该文件，联系算法相关人员进行算法模型的迁移，

如果有这两个文件，检测目录是否为`/data2/ai-algo-aat/cache/328/models/weights` ，如果不一致，讲文件迁移到该目录下即可。
